質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

88.81%

iosでjsonをpostしたいのですが..

受付中

回答 1

投稿 編集

  • 評価
  • クリップ 1
  • VIEW 2,313

daidaidada

score 13

iosからjsonをdjangoのローカルサーバーにpostしたいのですがrequest.POSTするとkeyerrorになり取得できません。
ios側でどうすればkeyを付加できるのでしょうか?

コード
 let url = "http://192.168.10.13:8000/pic/"
        var request = NSMutableURLRequest(url: NSURL(string: url)! as URL)

        // set the method(HTTP-POST)
        request.httpMethod = "POST"
        // set the header(s)
        request.addValue("application/json", forHTTPHeaderField: "Content-Type")

        // set the request-body(JSON)
        var params = Dictionary<String,Any>()
        params["x"] = originalTapPoint.x
        params["y"] = originalTapPoint.y
        do{
            request.httpBody = try JSONSerialization.data(withJSONObject: params, options: [])
        }catch{
            print(error.localizedDescription)
        }

        // use NSURLSessionDataTask
        let task = URLSession.shared.dataTask(with: request as URLRequest, completionHandler: {data, response, error in
            if (error == nil) {
                let result = NSString(data: data!, encoding: String.Encoding.utf8.rawValue)!
                print(result)
            } else {
                print(error)
            }
        })
        task.resume()


error log

[19/Jul/2017 03:41:04] "GET /media/pic/pic_for_calib.JPG HTTP/1.1" 304 0
b'{"y":152.5,"x":183.5}'
Internal Server Error: /pic/
Traceback (most recent call last):
  File "/Users/hoge/.virtualenvs/neochi/lib/python3.6/site-packages/django/utils/datastructures.py", line 83, in __getitem__
    list_ = super(MultiValueDict, self).__getitem__(key)
KeyError: 'result'

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/Users/hoge.virtualenvs/neochi/lib/python3.6/site-packages/django/core/handlers/exception.py", line 41, in inner
    response = get_response(request)
  File "/Users/hoge/.virtualenvs/neochi/lib/python3.6/site-packages/django/core/handlers/base.py", line 187, in _get_response
    response = self.process_exception_by_middleware(e, request)
  File "/Users/hoge/.virtualenvs/neochi/lib/python3.6/site-packages/django/core/handlers/base.py", line 185, in _get_response
    response = wrapped_callback(request, *callback_args, **callback_kwargs)
  File "/Users/hoge/.virtualenvs/neochi/lib/python3.6/site-packages/django/views/generic/base.py", line 68, in view
    return self.dispatch(request, *args, **kwargs)
  File "/Users/hoge/.virtualenvs/neochi/lib/python3.6/site-packages/django/utils/decorators.py", line 67, in _wrapper
    return bound_func(*args, **kwargs)
  File "/Users/hoge/.virtualenvs/neochi/lib/python3.6/site-packages/django/views/decorators/csrf.py", line 58, in wrapped_view
    return view_func(*args, **kwargs)
  File "/Users/hoge/.virtualenvs/neochi/lib/python3.6/site-packages/django/utils/decorators.py", line 63, in bound_func
    return func.__get__(self, type(self))(*args2, **kwargs2)
  File "/Users/hoge/neochi/neochi_web/calibrator/views.py", line 17, in dispatch
    return super(PicView, self).dispatch(request, *args, **kwargs)
  File "/Users/hoge/.virtualenvs/neochi/lib/python3.6/site-packages/django/views/generic/base.py", line 88, in dispatch
    return handler(request, *args, **kwargs)
  File "/Users/hoge/neochi/neochi_web/calibrator/views.py", line 42, in post
    jsondata = request.POST['result']
  File "/Users/hoge/.virtualenvs/neochi/lib/python3.6/site-packages/django/utils/datastructures.py", line 85, in __getitem__
    raise MultiValueDictKeyError(repr(key))
django.utils.datastructures.MultiValueDictKeyError: "'result'"
  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

質問への追記・修正、ベストアンサー選択の依頼

  • ykws

    2017/07/19 13:37

    エラーメッセージを要約せずに正確に書けますか? またサーバに対して、 iOS 経由ではなく、直接 WEB API を叩いた場合は問題なく動作する状態でしょうか?

    キャンセル

  • daidaidada

    2017/07/19 13:51

    直接の場合は問題なさそうです。

    キャンセル

回答 1

0

var params = Dictionary<String,Any>()
params["x"] = originalTapPoint.x
params["y"] = originalTapPoint.y

request.httpBody = try JSONSerialization.data(withJSONObject: params, options: [])

上のコードで下記 JSON を渡していることになっていて、(値はエラーメッセージから拝借)

{
  "x":183.5,
  "y":152.5
}

エラーメッセージから上記 JSON に result というキーが含まれていないのが原因ではないですか?

 File "/Users/hoge/.virtualenvs/neochi/lib/python3.6/site-packages/django/utils/datastructures.py", line 83, in __getitem__
    list_ = super(MultiValueDict, self).__getitem__(key)
KeyError: 'result'

投稿

編集

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2017/07/19 14:04

    ios側からpostするときにどうすればkeyをつけれるのでしょうか?

    キャンセル

  • 2017/07/19 14:11

    回答に JSON について追記しました。 key はすでにつけることができているので WEB API の仕様に合わせて JSON を組めば良いと思います。

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 88.81%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

関連した質問

同じタグがついた質問を見る